<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmMetasService;
use Zeedhi\Framework\DTO\Response;

class CrmMetasController
{

    protected $CrmMetasService;

    use TResponse;

    public function __construct(CrmMetasService $CrmMetasService)
    {
        $this->CrmMetasService = $CrmMetasService;
    }

    public function getCrmMetasController()
    {
        try {
            $data = $this->CrmMetasService->getCrmMetasService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveEditMeta(Request $request){
        try {
            $rows = $request->getParameters();
            $data = $this->CrmMetasService->saveEditMeta($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function saveNewMeta(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmMetasService->saveNewMeta($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


public function saveOperadorMeta(Request $request)
{
    try {
        $rows = $request->getParameters();
        $data = $this->CrmMetasService->saveOperadorMeta($rows);
        $this->sendResponse($data, 200);
    } catch (\Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
    }
}

    public function getOperadoresMeta(Request $request)
    {
        try {
            $data = $this->CrmMetasService->getOperadoresMeta($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }

    }
    public function getOperadorMeta(Request $request)
    {
        try {
            $data = $this->CrmMetasService->getOperadorMeta($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }

    }

    public function deleteCrmMetaOperador(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmMetasService->deleteCrmMetaOperador($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      
        }  
    }
    public function deleteCrmMetaRegistro(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmMetasService->deleteCrmMetaRegistro($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      
        }  
    }

}

