<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmModalidadeDePagamentoService;

class CrmModalidadeDePagamentoController{

    protected $CrmModalidadeDePagamentoService;

    use TResponse;

    public function __construct(CrmModalidadeDePagamentoService $CrmModalidadeDePagamentoService)
    {
        $this->CrmModalidadeDePagamentoService = $CrmModalidadeDePagamentoService;
    }

    public function getModalityPayment(){
        try {
          
            $data = $this->CrmModalidadeDePagamentoService->getModalityPaymentService();
            $this->sendResponse($data, 200);

        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function formOfPayment(){
        try {
          
            $data = $this->CrmModalidadeDePagamentoService->formOfPaymentService();
            $this->sendResponse($data, 200);

        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
    
    public function typeOfPayment(){
        try {
          
            $data = $this->CrmModalidadeDePagamentoService->typeOfPaymentService();
            $this->sendResponse($data, 200);

        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveNewModalityPayment(Request $request)
    {
        try {
            $data = $this->CrmModalidadeDePagamentoService->saveNewModalityPaymentService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteModalityPayment(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmModalidadeDePagamentoService->deleteModalityPaymentService($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    
    public function updateModalityPayment(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CrmModalidadeDePagamentoService->updateModalityPaymentService($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}