<?php

namespace CRM\Service;

use CRM\Factory\CrmEnderecoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmEnderecoService
{

    protected $CrmEnderecoFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmEnderecoFactory $CrmEnderecoFactory)
    {
        $this->CrmEnderecoFactory = $CrmEnderecoFactory;
        $this->environment           = $environment;
        $this->newCode               = $newCode;
        $this->connection            = $entityManager->getConnection();
    }

    public function getPaisService()
    {
        return $this->CrmEnderecoFactory->getPaisFactory();
    }


    public function getEstadoService($params)
    {
        return $this->CrmEnderecoFactory->getEstadoFactory(array(
            "CDPAIS" => isset($params['CDPAIS']) ? $params['CDPAIS'] : null,
        ));
    }
}
