create or replace PROCEDURE AJUSTE_CONTAPAGAR_NF
(
   P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
   P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_IDSTATUS   IN NOTAFISCAL.IDSTATUS%TYPE
)
IS
   V_VRATUAAF_VRDESC NUMBER;
   V_PREV_VRATUAPAG  NUMBER;
   V_VRATUAPAGAUX    NUMBER;
   V_VALORDEVOLVIDO  NUMBER;
   V_DIFERENCA       NUMBER;
   V_NRSEQVENPAGAUX  NUMBER;
   V_VRTOTPREV       NUMBER;
   V_VRMOVFLUXO      NUMBER;
   V_NRLANCTONFAUX   NUMBER;
   V_DESCFLUXO       NUMBER;
   V_NRSEQVENPAGFLUX NUMBER;
   V_NRAUTOFORNAUX   NUMBER;
   V_DTPROGENTAFAUX  DATE;

   V_IDSTATUSAUX     VARCHAR2(1);
   V_IDGERCONTPGT    VARCHAR2(1);
   V_IDCONSORCFIN    VARCHAR2(1);
   V_IDTPORCAFINA    VARCHAR2(1);
   V_CDFILIAL        VARCHAR2(4);
   V_CDFILLANCAUX    VARCHAR2(4);
   V_CDFILDESTAUX    VARCHAR2(4);
   V_COUNT           NUMBER;
   V_CDFORNECED      VARCHAR2(21);
   V_CDFORNECEDRELAC VARCHAR2(21);

BEGIN
   FOR C_NOTAREAL IN
      (SELECT IDENTRSAIDOP, CDFORNECED
         FROM NOTAFISCAL
        WHERE CDFILIAL   = P_CDFILIAL
          AND NRLANCTONF = P_NRLANCTONF)
   LOOP
      V_VRMOVFLUXO := 0;

      IF (C_NOTAREAL.IDENTRSAIDOP = 'E') AND (C_NOTAREAL.CDFORNECED IS NOT NULL) THEN /* SE A NOTA FOR DE ENTRADA DE FORNECEDOR */
         IF (P_IDSTATUS IN ('E', 'A')) THEN

			   V_CDFORNECED := C_NOTAREAL.CDFORNECED;
               FOR C_AUTOFORNE IN /* PEGA AS AF'S RELACIONADAS  NOTA */
                  (SELECT DISTINCT CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO,DTPROGENTAF
                     FROM NFRELACAF
                    WHERE CDFILIAL   = P_CDFILIAL
                      AND NRLANCTONF = P_NRLANCTONF) LOOP

                  V_CDFILLANCAUX  := C_AUTOFORNE.CDFILLANC;
                  V_CDFILDESTAUX  := C_AUTOFORNE.CDFILDEST;
                  V_NRAUTOFORNAUX := C_AUTOFORNE.NRAUTOFORN;

                  FOR C_NOTAPREVISTA IN /* PEGA A NOTA DA CONTA A PAGAR PREVISTA */
                     (SELECT DISTINCT IT.NRLANCTONF, DTPROGENTAF
                        FROM ITEMAUTF IT, NOTAFISCAL NF
                       WHERE IT.CDFILLANC  = C_AUTOFORNE.CDFILLANC
                         AND IT.CDFILDEST  = C_AUTOFORNE.CDFILDEST
                         AND IT.NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN
                         AND IT.CDPRODUTO  = C_AUTOFORNE.CDPRODUTO
								 AND IT.DTPROGENTAF = C_AUTOFORNE.DTPROGENTAF
                         AND IT.CDFILLANC  = NF.CDFILIAL
                         AND IT.NRLANCTONF = NF.NRLANCTONF
                         AND NF.IDSTATUS NOT IN ('C','R')) LOOP

                     V_NRLANCTONFAUX  := C_NOTAPREVISTA.NRLANCTONF;
                     V_DTPROGENTAFAUX := C_NOTAPREVISTA.DTPROGENTAF;

                          SELECT SUM(VRATUAPAG)
                           INTO V_VRTOTPREV
                           FROM CONTAPAGAR
                          WHERE CDFILIAL   = C_AUTOFORNE.CDFILLANC
                            AND NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;


                     FOR C_DESCNOTA IN /* PEGA OS DADOS DAS CONTAS A PAGAR PREVISTA  */
                        (SELECT VRORIGPAG, VRATUAPAG, NRSEQVENPAG
                           FROM CONTAPAGAR
                          WHERE CDFILIAL   = C_AUTOFORNE.CDFILLANC
                            AND NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF
                          ORDER BY DTORIGVENPAG)
                     LOOP

                        SELECT SUM(VRTOTAITEM)
                          INTO V_VRATUAAF_VRDESC
                         FROM  NOTAFISCAL NF,ITEMPRODUTO IT
                        WHERE NF.CDFILIAL   = P_CDFILIAL
                          AND NF.NRLANCTONF = P_NRLANCTONF
                          AND IT.CDFILIAL = NF.CDFILIAL
                          AND IT.NRLANCTONF = NF.NRLANCTONF
                          AND IT.CDPRODUTO = C_AUTOFORNE.CDPRODUTO
								  AND IT.DTPROGENTAF = C_NOTAPREVISTA.DTPROGENTAF;

                        V_PREV_VRATUAPAG := C_DESCNOTA.VRATUAPAG;

                        V_VRATUAAF_VRDESC := ROUND((C_DESCNOTA.VRATUAPAG * V_VRATUAAF_VRDESC) / V_VRTOTPREV,2);

                        IF (V_VRATUAAF_VRDESC > 0) OR (V_PREV_VRATUAPAG <= 0) THEN
                           IF V_PREV_VRATUAPAG > V_VRATUAAF_VRDESC THEN
                              V_PREV_VRATUAPAG  := V_PREV_VRATUAPAG - V_VRATUAAF_VRDESC;
                              V_VRATUAAF_VRDESC := 0;
                           ELSE
                              V_VRATUAAF_VRDESC := V_VRATUAAF_VRDESC - V_PREV_VRATUAPAG;
                              V_PREV_VRATUAPAG  := 0;
                           END IF;
                        END IF;
                        UPDATE CONTAPAGAR
                           SET VRATUAPAG   = V_PREV_VRATUAPAG
                         WHERE CDFILIAL    = C_AUTOFORNE.CDFILLANC
                           AND NRLANCTONF  = C_NOTAPREVISTA.NRLANCTONF
                           AND NRSEQVENPAG = C_DESCNOTA.NRSEQVENPAG;
                        SELECT SUM(CONTAPAGAR.VRATUAPAG)
                          INTO V_VRATUAPAGAUX
                          FROM CONTAPAGAR
                         WHERE CONTAPAGAR.CDFILIAL   = C_AUTOFORNE.CDFILLANC
                           AND CONTAPAGAR.NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;

                        V_COUNT := 0;
                          BEGIN
                            SELECT COUNT(1)
                              INTO V_COUNT
                              FROM AUTOFORNE AF, ITEMAUTF IT
                             WHERE AF.CDFILDEST = IT.CDFILDEST
                               AND AF.CDFILLANC = IT.CDFILLANC
                               AND AF.NRAUTOFORN = IT.NRAUTOFORN
                               AND IT.IDBAIXITMAF <> '2'
                               AND IT.CDFILLANC = C_AUTOFORNE.CDFILLANC
                               AND IT.NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_COUNT := 0;
                         END;

                        V_IDSTATUSAUX := 'V';
								IF ((V_VRATUAPAGAUX <= 0.05) OR (V_COUNT = 0)) THEN
						         V_IDSTATUSAUX := 'C';
                        END IF;

                        UPDATE NOTAFISCAL
                           SET IDSTATUS   = V_IDSTATUSAUX
                         WHERE CDFILIAL   = C_AUTOFORNE.CDFILLANC
                           AND NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;

                     END LOOP;
                  END LOOP;
               END LOOP;
               FOR C_CONTAPAGAR IN
                  (SELECT C.CDEMPRESA,
                          C.DTMOVFLUXO,
                          C.IDMOVFLUXO,
                          C.CDCLASSFINA,
                          C.VRORIGPAG,
                          C.VRATUAPAG
                     FROM CONTAPAGAR C, NOTAFISCAL NF
                    WHERE C.CDFILIAL   = V_CDFILLANCAUX
                      AND C.NRLANCTONF = V_NRLANCTONFAUX
                      AND V_NRLANCTONFAUX IS NOT NULL
                      AND C.CDFILIAL = NF.CDFILIAL
                      AND C.NRLANCTONF = NF.NRLANCTONF
                      AND NVL(NF.IDORIGDESTNF,'T') <> 'L')
               LOOP

                  ATUALIZA_FLUXO_DE_CAIXA(C_CONTAPAGAR.CDEMPRESA,
                                          V_CDFILDESTAUX,
                                          C_CONTAPAGAR.DTMOVFLUXO,
                                          C_CONTAPAGAR.IDMOVFLUXO,
                                          C_CONTAPAGAR.CDCLASSFINA,
                                          0,
                                          - C_CONTAPAGAR.VRORIGPAG);

                  UPDATE MOVFLUXAF
                     SET VRPREVAF = VRPREVAF - C_CONTAPAGAR.VRORIGPAG
                   WHERE CDFILDEST    = V_CDFILDESTAUX
                     AND CDFILLANC    = V_CDFILLANCAUX
                     AND NRAUTOFORN   = V_NRAUTOFORNAUX
                     AND CDCLASSFINAF = C_CONTAPAGAR.CDCLASSFINA
                     AND DTENTMOVAF   = V_DTPROGENTAFAUX
                     AND DTPREVVENC   = C_CONTAPAGAR.DTMOVFLUXO;

                  SELECT IDCONSORCFIN, IDTPORCAFINA
                    INTO V_IDCONSORCFIN, V_IDTPORCAFINA
                    FROM PARAMGERAL;

                  IF V_IDCONSORCFIN = 'S' THEN
                     V_CDFILIAL := NULL;
                     IF V_IDTPORCAFINA = 'F' THEN
                        V_CDFILIAL := V_CDFILDESTAUX;
                     END IF;
                     FOR C_ORCAFINA IN
                        (SELECT CDEMPRESA,
                                CDFILIAL,
                                CDCLASSFINA,
                                DTORCAFINA
                           FROM ORCAFINA
                          WHERE (CDEMPRESA   = C_CONTAPAGAR.CDEMPRESA)
                            AND (CDFILIAL    = NVL(V_CDFILIAL, CDFILIAL))
                            AND (CDCLASSFINA = C_CONTAPAGAR.CDCLASSFINA)
                            AND (DTORCAFINA BETWEEN TO_DATE(C_CONTAPAGAR.DTMOVFLUXO) - TO_CHAR(TO_DATE(C_CONTAPAGAR.DTMOVFLUXO), 'DD') + 1
                                                AND LAST_DAY(C_CONTAPAGAR.DTMOVFLUXO)))
                     LOOP

                        UPDATE ORCAFINA
                           SET VRREALORCA  = VRREALORCA - C_CONTAPAGAR.VRORIGPAG
                         WHERE CDCLASSFINA = C_ORCAFINA.CDCLASSFINA AND
                               CDEMPRESA   = C_ORCAFINA.CDEMPRESA AND
                               DTORCAFINA  = C_ORCAFINA.DTORCAFINA AND
                               CDFILIAL    = C_ORCAFINA.CDFILIAL;
                     END LOOP;
                  END IF;
               END LOOP;
            --END IF;
         ELSE
			   V_CDFORNECED := C_NOTAREAL.CDFORNECED;
               FOR C_AUTOFORNE IN /* PEGA AS AF'S RELACIONADAS  NOTA */
                  (SELECT DISTINCT CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO
                     FROM NFRELACAF
                    WHERE CDFILIAL   = P_CDFILIAL
                      AND NRLANCTONF = P_NRLANCTONF)
               LOOP

                  V_CDFILLANCAUX  := C_AUTOFORNE.CDFILLANC;
                  V_CDFILDESTAUX  := C_AUTOFORNE.CDFILDEST;
                  V_NRAUTOFORNAUX := C_AUTOFORNE.NRAUTOFORN;

                  FOR C_NOTAPREVISTA IN /* PEGA O NUMERO DE LANAMENTO DA CONTA PREVISTA */
                     (SELECT DISTINCT NRLANCTONF, DTPROGENTAF
                        FROM ITEMAUTF
                       WHERE CDFILLANC  = C_AUTOFORNE.CDFILLANC
                         AND CDFILDEST  = C_AUTOFORNE.CDFILDEST
                         AND NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN
								 AND CDPRODUTO =  C_AUTOFORNE.CDPRODUTO) LOOP

                     V_NRLANCTONFAUX  := C_NOTAPREVISTA.NRLANCTONF;
                     V_DTPROGENTAFAUX := C_NOTAPREVISTA.DTPROGENTAF;

                     /* PEGA OS DADOS DA NOTA QUE FOI IMPORTADA PELA AF */
                     SELECT SUM(VRATUAPAG)
                       INTO V_VRATUAAF_VRDESC
                       FROM CONTAPAGAR
                      WHERE CDFILIAL   = P_CDFILIAL
                        AND NRLANCTONF = P_NRLANCTONF;

                     V_VALORDEVOLVIDO := V_VRATUAAF_VRDESC;
                     V_DIFERENCA := 0;

                     FOR C_DESCPREVISTA IN
                        (SELECT VRORIGPAG, VRATUAPAG, NRSEQVENPAG
                           FROM CONTAPAGAR
                          WHERE CDFILIAL   = C_AUTOFORNE.CDFILLANC
                            AND NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF
                          ORDER BY NRSEQVENPAG DESC)
                     LOOP

                        IF V_VALORDEVOLVIDO >= 0 THEN
                           IF C_DESCPREVISTA.VRATUAPAG <> C_DESCPREVISTA.VRORIGPAG THEN
                              V_DIFERENCA := C_DESCPREVISTA.VRORIGPAG - C_DESCPREVISTA.VRATUAPAG;

                              IF V_DIFERENCA > V_VALORDEVOLVIDO THEN
                                 UPDATE CONTAPAGAR
                                    SET VRATUAPAG   = C_DESCPREVISTA.VRATUAPAG + V_VALORDEVOLVIDO
                                  WHERE CDFILIAL    = C_AUTOFORNE.CDFILLANC
                                    AND NRLANCTONF  = C_NOTAPREVISTA.NRLANCTONF
                                    AND NRSEQVENPAG = C_DESCPREVISTA.NRSEQVENPAG;
                              ELSE
                                 UPDATE CONTAPAGAR
                                    SET VRATUAPAG   = C_DESCPREVISTA.VRATUAPAG + V_DIFERENCA
                                  WHERE CDFILIAL    = C_AUTOFORNE.CDFILLANC
                                    AND NRLANCTONF  = C_NOTAPREVISTA.NRLANCTONF
                                    AND NRSEQVENPAG = C_DESCPREVISTA.NRSEQVENPAG;
                              END IF;

                              UPDATE NOTAFISCAL
                                 SET IDSTATUS   = 'V'
                               WHERE CDFILIAL   = C_AUTOFORNE.CDFILLANC
                                 AND NRLANCTONF = C_NOTAPREVISTA.NRLANCTONF;

                              V_VALORDEVOLVIDO := V_VALORDEVOLVIDO - V_DIFERENCA;
                           END IF;
                        END IF;
                     END LOOP;
                  END LOOP;
               END LOOP;
               FOR C_CONTAPAGAR IN
                  (SELECT C.CDEMPRESA,
                          C.DTMOVFLUXO,
                          C.IDMOVFLUXO,
                          C.CDCLASSFINA,
                          C.VRORIGPAG,
                          C.VRATUAPAG
                     FROM CONTAPAGAR C, NOTAFISCAL NF
                    WHERE C.CDFILIAL   = V_CDFILLANCAUX
                      AND C.NRLANCTONF = V_NRLANCTONFAUX
                      AND V_NRLANCTONFAUX IS NOT NULL
                      AND C.CDFILIAL = NF.CDFILIAL
                      AND C.NRLANCTONF = NF.NRLANCTONF
                      AND NVL(NF.IDORIGDESTNF,'T') <> 'L')
               LOOP

                  ATUALIZA_FLUXO_DE_CAIXA(C_CONTAPAGAR.CDEMPRESA,
                                          V_CDFILDESTAUX,
                                          C_CONTAPAGAR.DTMOVFLUXO,
                                          C_CONTAPAGAR.IDMOVFLUXO,
                                          C_CONTAPAGAR.CDCLASSFINA,
                                          0,
                                          C_CONTAPAGAR.VRORIGPAG);

                  UPDATE MOVFLUXAF
                     SET VRPREVAF = VRPREVAF + C_CONTAPAGAR.VRORIGPAG
                   WHERE CDFILDEST    = V_CDFILDESTAUX
                     AND CDFILLANC    = V_CDFILLANCAUX
                     AND NRAUTOFORN   = V_NRAUTOFORNAUX
                     AND CDCLASSFINAF = C_CONTAPAGAR.CDCLASSFINA
                     AND DTENTMOVAF   = V_DTPROGENTAFAUX
                     AND DTPREVVENC   = C_CONTAPAGAR.DTMOVFLUXO;
                  SELECT IDCONSORCFIN, IDTPORCAFINA
                    INTO V_IDCONSORCFIN, V_IDTPORCAFINA
                    FROM PARAMGERAL;

                  IF V_IDCONSORCFIN = 'S' THEN
                     V_CDFILIAL := NULL;
                     IF V_IDTPORCAFINA = 'F' THEN
                        V_CDFILIAL := V_CDFILDESTAUX;
                     END IF;
                     FOR C_ORCAFINA IN
                        (SELECT CDEMPRESA,
                                CDFILIAL,
                                CDCLASSFINA,
                                DTORCAFINA
                           FROM ORCAFINA
                          WHERE (CDEMPRESA   = C_CONTAPAGAR.CDEMPRESA)
                            AND (CDFILIAL    = NVL(V_CDFILIAL, CDFILIAL))
                            AND (CDCLASSFINA = C_CONTAPAGAR.CDCLASSFINA)
                            AND (DTORCAFINA BETWEEN TO_DATE(C_CONTAPAGAR.DTMOVFLUXO) - TO_CHAR(TO_DATE(C_CONTAPAGAR.DTMOVFLUXO), 'DD') + 1
                                                AND LAST_DAY(C_CONTAPAGAR.DTMOVFLUXO)))
                     LOOP

                        UPDATE ORCAFINA
                           SET VRREALORCA  = VRREALORCA + C_CONTAPAGAR.VRORIGPAG
                         WHERE CDCLASSFINA = C_ORCAFINA.CDCLASSFINA AND
                               CDEMPRESA   = C_ORCAFINA.CDEMPRESA AND
                               DTORCAFINA  = C_ORCAFINA.DTORCAFINA AND
                               CDFILIAL    = C_ORCAFINA.CDFILIAL;
                     END LOOP;
                  END IF;
               END LOOP;
            END IF;
        -- END IF;
      END IF;
   END LOOP;
END;
/

